// Generated by CoffeeScript 1.6.3
(function () {
	window.Card = (function () {
		Card.prototype.FRONT_IMAGE_SPACE = 12;

		Card.prototype.type = void 0;

		Card.prototype.imagePath = void 0;

		Card.prototype.backPath = void 0;

		Card.prototype.image = void 0;

		Card.prototype.backImage = void 0;

		Card.prototype.frontImage = void 0;

		Card.prototype.x = void 0;

		Card.prototype.y = void 0;

		Card.prototype.animationDifference = void 0;

		Card.prototype.exitAnimationStep = void 0;

		function Card(type, imagePath) {
			this.type = type;
			this.imagePath = imagePath;
			this.backPath = cardBacks[Math.round(Math.random() * (cardBacks.length - 1))];
			this.setBackImage();
			this.setFrontImage();
		}

		Card.prototype.setBackImage = function () {
			var card;
			card = this;
			this.backImage = new paper.Raster(this.backPath);
			return this.backImage.onLoad = function () {
				return card.backImage.size = new paper.Size(graphic.cardSize, graphic.cardSize);
			};
		};

		Card.prototype.setClickListener = function () {
			var card;
			card = this;
			return this.backImage.onMouseDown = function () {
				statistics.setPlusOneClick();
				if ((window.secondCard != null)) {
					window.opennedCard.close();
					window.secondCard.close();
					window.opennedCard = void 0;
					window.secondCard = void 0;
				}
				card.frontImage.visible = true;
				card.image.visible = true;
				if ((window.opennedCard != null)) {
					if (window.opennedCard.type === card.type) {
						window.allCards.push(window.opennedCard, card);
						window.opennedCard = void 0;
						window.secondCard = void 0;
						return statistics.setPairFound();
					} else {
						return window.secondCard = card;
					}
				} else {
					return window.opennedCard = card;
				}
			};
		};

		Card.prototype.setFrontImage = function () {
			var card;
			card = this;
			var roundSize =  new paper.Size(graphic.cardSize/10, graphic.cardSize/10);
			this.frontImage = new paper.Path.Rectangle(new paper.Point(0, 0), new paper.Size(graphic.cardSize, graphic.cardSize),roundSize);
			this.frontImage.fillColor = "#fff";
			this.image = new paper.Raster(this.imagePath);
			this.image.onLoad = function () {
				return card.image.size = new paper.Size(graphic.cardSize - card.FRONT_IMAGE_SPACE * 2, graphic.cardSize - card.FRONT_IMAGE_SPACE * 2);
			};
			return this.close();
		};

		Card.prototype.animateBack = function () {
			this.animationDifference /= 2;
			return this.backImage.position = new paper.Point(this.x - this.animationDifference, this.y);
		};

		Card.prototype.close = function () {
			this.frontImage.visible = false;
			return this.image.visible = false;
		};

		Card.prototype.setCoordinates = function (x, y) {
			this.x = x;
			this.y = y;
			this.animationDifference = graphic.CANVAS_SIZE;
			this.backImage.position = new paper.Point(this.x - this.animationDifference, this.y);
			this.frontImage.position = new paper.Point(this.x, this.y);
			return this.image.position = new paper.Point(this.x, this.y);
		};

		Card.prototype.animateExit = function () {
			if (this.exitAnimationStep === void 0) {
				this.exitAnimationStep = ANIMATION_DURATION / ANIMATION_FRAME_DURATION;
				this.backImage.visible = false;
			}
			this.animationDifference += graphic.CANVAS_SIZE / this.exitAnimationStep;
			this.frontImage.position = new paper.Point(this.x + this.animationDifference, this.y);
			this.image.position = new paper.Point(this.x + this.animationDifference, this.y);
			return this.exitAnimationStep--;
		};

		Card.prototype.setBackOnPlace = function () {
			this.backImage.position = new paper.Point(this.x, this.y);
			return this.animationDifference = 0;
		};

		Card.prototype.remove = function () {
			this.image.remove();
			this.frontImage.remove();
			return this.backImage.remove();
		};

		return Card;

	})();

}).call(this);
