// Generated by CoffeeScript 1.6.3
(function () {
	var initialize, onResize, placeLevelCards, setLevelCards;
	$('#start-block').css('display', 'none');
	window.statistics = window.server = window.graphic = void 0;

	window.WINDOW_WIDTH = window.WINDOW_HEIGHT = 0;

	window.cards = void 0;

	window.opennedCard = window.secondCard = void 0;

	window.allCards = void 0;

	window.animationTimer = window.animationCounter = void 0;

	onResize = function () {
		window.WINDOW_WIDTH = $(window).width();
		window.WINDOW_HEIGHT = $(window).height();
		window.statistics.resize();
		return window.graphic.resize();
	};

	window.startNewLevel = function () {
		if ((window.allCards != null)) {
			statistics.cardsOpenned = 0;
			while (window.allCards.length > 0) {
				window.allCards[0].remove();
				window.allCards.splice(0, 1);
			}
		}
		window.allCards = new Array();
		//window.statistics.setNewStatistics();
		window.graphic.setCardsVariables();
		setLevelCards();
		placeLevelCards();
		window.animationCounter = 0;
		return window.animationTimer = setInterval(window.cardsEnterAnimation, ANIMATION_FRAME_DURATION);
	};

	window.cardsEnterAnimation = function () {
		var i, _i, _ref;
		window.animationCounter += ANIMATION_FRAME_DURATION;
		for (i = _i = 0, _ref = window.cards.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
			if (window.animationCounter >= ANIMATION_DURATION) {
				window.cards[i].setBackOnPlace();
				window.cards[i].setClickListener();
			} else {
				window.cards[i].animateBack();
			}
		}
		if (window.animationCounter >= ANIMATION_DURATION) {
			window.clearInterval(window.animationTimer);
			statistics.startTimer();
		}
		return graphic.redraw();
	};

	window.setEndLevelAnimation = function () {
		window.animationCounter = 0;
		return window.animationTimer = setInterval(window.cardsExitAnimation, ANIMATION_FRAME_DURATION);
	};

	window.cardsExitAnimation = function () {
		var i, _i, _ref;
		window.animationCounter += ANIMATION_FRAME_DURATION;
		for (i = _i = 0, _ref = window.cards.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
			window.cards[i].animateExit();
		}
		if (window.animationCounter >= ANIMATION_DURATION) {
			window.clearInterval(window.animationTimer);
			statistics.level += 2;
			if (statistics.level > MAX_ROW_CARDS) {
				statistics.showLevelInfo();
				//window.location = 'index.html';
				//_this.level = MIN_ROW_CARDS;
			} else {
				statistics.hideLeaderBoard();
				statistics.showStats();
				statistics.showGameName();
				return startNewLevel();
			}
		}
		return graphic.redraw();
	};

	setLevelCards = function () {
		var card1, card2, i, imagePath, images, randomImageNumber, _i, _ref, _results;
		window.cards = new Array();
		images = cardIcons.slice(0);
		_results = [];
		for (i = _i = 0, _ref = statistics.level * statistics.level / 2 - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
			randomImageNumber = Math.round(Math.random() * (images.length - 1));
			imagePath = images[randomImageNumber];
			images.splice(randomImageNumber, 1);
			card1 = new Card(i, imagePath);
			card2 = new Card(i, imagePath);
			_results.push(window.cards.push(card1, card2));
		}
		return _results;
	};

	placeLevelCards = function () {
		var i, j, randomArrIndex, tempArr, _i, _j, _ref, _ref1;
		tempArr = new Array();
		for (i = _i = 0, _ref = statistics.level - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
			for (j = _j = 0, _ref1 = statistics.level - 1; 0 <= _ref1 ? _j <= _ref1 : _j >= _ref1; j = 0 <= _ref1 ? ++_j : --_j) {
				randomArrIndex = Math.round(Math.random() * (window.cards.length - 1));
				window.cards[randomArrIndex].setCoordinates(window.graphic.CARD_SPACE * (i + 1) + (i * window.graphic.cardSize) + window.graphic.cardSize / 2, window.graphic.CARD_SPACE * (j + 1) + (j * window.graphic.cardSize) + window.graphic.cardSize / 2);
				tempArr.push(window.cards[randomArrIndex]);
				window.cards.splice(randomArrIndex, 1);
			}
		}
		return window.cards = tempArr;
	};

	initialize = function () {
		var _this = this;
		window.graphic = new Graphic();
		window.server = new Server();
		window.statistics = new Statistics();
		$(window).resize(function (e) {
			return onResize();
		});
		onResize();
		$(function(){
			$('#gamename').text(gameName);
		});
		window.statistics.setNewStatistics();
		if(window.location.hash == '#scores'){
			statistics.setLeaderBoard();
		} else {
			startNewLevel();
		}
	};

	initialize();

}).call(this);
