// Generated by CoffeeScript 1.6.3
(function() {
  window.Graphic = (function() {
    Graphic.prototype.CANVAS_SIZE = 800;

    Graphic.prototype.MIN_CANVAS_SIZE = 50;

    Graphic.prototype.CARD_SPACE = 30;

    Graphic.prototype.domCanvas = void 0;

    Graphic.prototype.$canvas = void 0;

    Graphic.prototype.background = void 0;

    Graphic.prototype.cardSize = void 0;

    Graphic.prototype.borderRadius = 25;

    function Graphic() {
      this.setDomElements();
      this.setMainGraphics();
    }

    Graphic.prototype.setDomElements = function() {
      this.domCanvas = document.getElementById("canvas");
      paper.setup(this.domCanvas);
      return this.$canvas = $(this.domCanvas);
    };

    Graphic.prototype.setMainGraphics = function() {
      this.background = new paper.Path.Rectangle(new paper.Point(0, 0), new paper.Point(this.CANVAS_SIZE, this.CANVAS_SIZE));
      return this.background.fillColor = "#277fe4";
    };

    Graphic.prototype.setCardsVariables = function() {
      var spaceForDelimit;

      spaceForDelimit = (statistics.level + 1) * this.CARD_SPACE;
      return this.cardSize = (this.CANVAS_SIZE - spaceForDelimit) / statistics.level;

    };

    Graphic.prototype.redraw = function() {
      return paper.view.draw();
    };

    Graphic.prototype.resize = function() {
      var minSize;
      minSize = Math.min(WINDOW_WIDTH, WINDOW_HEIGHT - (statistics.DOM_ELEMENT_HEIGHT+100));
      if (minSize < this.MIN_CANVAS_SIZE) {
        minSize = this.MIN_CANVAS_SIZE;
      }
      paper.view.viewSize = new paper.Size(minSize, minSize);
      paper.view.zoom = minSize / this.CANVAS_SIZE;
      paper.view.size.width = minSize;
      paper.view.size.height = minSize;
      return paper.view.center = new paper.Point(minSize / 2, minSize / 2);
    };

    return Graphic;

  })();

}).call(this);
