// Generated by CoffeeScript 1.6.3
(function () {
	function isInApp(){
		return typeof AppsgeyserJSInterface != 'undefined';
	}

	function getAppId(){
		if(isInApp()){
			return AppsgeyserJSInterface.getAppId();
		}
		return 1;
	}

	function getInstallationGuid(){
		if(isInApp()){
			return AppsgeyserJSInterface.getInstallationGuid();
		}
		return '{00000000-0000-0000-0000-000000000000}';
	}


	window.Server = (function () {
		Server.prototype.nameParameter = "name";

		Server.prototype.timeParameter = "time";

		Server.prototype.clickParameter = "click";

		Server.prototype.totalPointsParameter = "totalPoints";

		Server.prototype.demoRecords = void 0;

		function Server() {
		}

		Server.prototype.setDemoRecords = function () {
			this.demoRecords = new Array();
			this.demoRecords.push(this.getRecordObject("user1", 20, 10));
			this.demoRecords.push(this.getRecordObject("user2", 22, 12));
			this.demoRecords.push(this.getRecordObject("user3", 24, 14));
			this.demoRecords.push(this.getRecordObject("user4", 26, 16));
			this.demoRecords.push(this.getRecordObject("user5", 28, 18));
			this.demoRecords.push(this.getRecordObject("user6", 30, 20));
			this.demoRecords.push(this.getRecordObject("user7", 32, 22));
			this.demoRecords.push(this.getRecordObject("user8", 34, 24));
			this.demoRecords.push(this.getRecordObject("user9", 36, 26));
			this.demoRecords.push(this.getRecordObject("user10", 38, 28));
		};

		Server.prototype.getRecordObject = function (name, time, click) {
			var recordObject;
			recordObject = new Object();
			recordObject[this.nameParameter] = name;
			recordObject[this.timeParameter] = time;
			recordObject[this.clickParameter] = click;
			recordObject[this.totalPointsParameter] = time + click;
			return recordObject;
		};

		Server.prototype.getRecords = function (callback) {
			$('.loading').show();
			$.ajax({
				url: 'http://54.243.57.80/index.php',
				data: {
					appid:getAppId(),
					installation_guid:getInstallationGuid(),
					method: 'get'
				},
				type: 'get',
				dataType:'jsonp',
				crossDomain:true,
				success: function(json){
					if(typeof callback == 'function') callback(json.leaderBoard);
				},
				error: function(e){
					//showError('Error loading leaderboard... Check your connection.');
					console.log("Ajax error: " + e.status + " " + e.statusText);
				},
				complete: function(){
					$('.loading').hide();
				}
			});
		};

		Server.prototype.saveRecord = function (user, score, callback) {
			$('.loading').show();
			$.ajax({
				url: 'http://54.243.57.80/index.php',
				data: {
					appid:getAppId(),
					installation_guid:getInstallationGuid(),
					score:score,
					user_name:user,
					method : 'post'
				},
				type: 'post',
				dataType:'jsonp',
				crossDomain:true,
				success: function(json){
					if(!json.submitted){
						//showError('Error submitting your score.'); TODO
						return;
					}
					if(typeof callback=='function') callback(json.leaderBoard);
					$('.send-score').hide();
				},
				error: function(e){
					//showError('Error submitting your score.'); TODO
					if(typeof callback=='function') callback();
				},
				complete: function(){
					$('.loading').hide();
				}
			});
		};

		return Server;

	})();

}).call(this);
