// Generated by CoffeeScript 1.6.3
(function () {
	window.Statistics = (function () {
		Statistics.prototype.DOM_ELEMENT_HEIGHT = 60;

		Statistics.prototype.$currentTimeText = $("#current_time");

		/*Statistics.prototype.$bestTimeText = $("#best_time");*/

		Statistics.prototype.$currentClickText = $("#current_click");

		/*Statistics.prototype.$bestClickText = $("#best_click");*/

		Statistics.prototype.currentTime = void 0;

		Statistics.prototype.currentClick = void 0;

		Statistics.prototype.playerName = void 0;

		Statistics.prototype.level = void 0;

		Statistics.prototype.records = void 0;

		Statistics.prototype.cardsOpenned = void 0;

		Statistics.prototype.timer = void 0;

		Statistics.prototype.$statsBlock = $("#statistics");

		Statistics.prototype.$gameNameBlock = $("#gamename");

		Statistics.prototype.$playerNameBlock = $("#name_block");

		Statistics.prototype.$inputNameBlock = $("#input_name_block");

		Statistics.prototype.$nameOkBtn = $("#name_ok_btn");

		Statistics.prototype.$nameInput = $("#name_input");

		Statistics.prototype.$leaderBoardBlock = $("#leader_board_block");

		Statistics.prototype.$leaderTableBlock = $("#leader_table_block");

		Statistics.prototype.$emptyLeadersBlock = $("#empty_leaders_block");

		Statistics.prototype.$recordsOkBtn = $("#records_ok_btn");

		function Statistics() {
			this.level = MIN_ROW_CARDS;
			this.setListeners();
		}

		Statistics.prototype.setListeners = function () {
			var _this = this;
			this.$nameOkBtn.bind("click", function (e) {
				if (_this.$nameInput.val() === "") {
					alert("enter name please");
					return;
				}
				_this.playerName = _this.$nameInput.val();
				_this.hideNameWindow();
				return _this.setLeaderBoard();
			});
			return this.$recordsOkBtn.bind("click", function (e) {

				window.location = 'index.html';
				/*_this.level += 2;
				 if (_this.level > MAX_ROW_CARDS) {
				 //_this.level = MIN_ROW_CARDS;
				 }
				 _this.hideLeaderBoard();
				 _this.showStats();
				 _this.showGameName();
				 return startNewLevel();*/
			});
		};

		Statistics.prototype.setNewStatistics = function () {
			var bestLevelParameters;
			this.currentClick = this.currentTime = this.cardsOpenned = 0;
			this.$currentClickText.text(this.currentClick);
			this.$currentTimeText.text(this.currentTime);
		};

		Statistics.prototype.startTimer = function () {
			return this.timer = setInterval(this.setPlusOneSecond, 1000);
		};

		Statistics.prototype.setDemoLeaderBoard = function () {
			this.currentTime = 21;
			this.currentClick = 30;
			this.playerName = "John Doe";
			this.records = JSON.parse(server.getRecords(this.level));
			return this.setLeaderBoard();
		};

		Statistics.prototype.setPairFound = function () {
			this.cardsOpenned += 2;
			if (this.cardsOpenned === Math.pow(this.level, 2)) {
				window.clearInterval(this.timer);
				return setEndLevelAnimation();
			}
		};

		Statistics.prototype.showLevelInfo = function () {
			if ((this.playerName != null)) {
				return this.setLeaderBoard();
			} else {
				this.hideStats();
				this.hideGameName();
				return this.showNameWindow();
			}
		};

		Statistics.prototype.setLeaderBoard = function () {
			this.hideGameName();
			this.hideStats();
			this.$emptyLeadersBlock.empty();
			this.showLeaderBoard();
			var that = this;
			this.savePlayerResultIfNeeded(function(records){
				that.records = records;
				that.writeRecordsTable();
			});
		};

		Statistics.prototype.savePlayerResultIfNeeded = function (callback) {
			var that = this;
			server.getRecords(function(records){
				that.records = records;
				if(that.currentClick == 0) {callback(records); return;}
				var i, totalPoints, _results;

				totalPoints = that.currentClick + that.currentTime;
				server.saveRecord(that.playerName, -totalPoints,callback);
			});
		};

		Statistics.prototype.writeRecordsTable = function () {
			var top = this.records.top;

			var recordTable, str;
			recordTable = $("<div>", {
				"class": "main-block"

			});
			recordTable.append("<div id=" + '"records"' + " style=" + '"color: #ffffff"' + ">Records</div><div class=" + '"top-tab"' + "><div class=" + '"tab"' + ">N</div><div class=" + '"tab name"' + ">name</div> <div class=" + '"tab"' + ">score</div></div>");
			for (var i = 0; i < top.length; i++) {
				str = "<div class=" + '"results"' + ">";
				str += "<div class=" + '"results-tab"' + ">" + top[i].position + "</div>";
				str += "<div class=" + '"results-tab"' + ">" + top[i].name + "</div>";
				str += "<div class=" + '"results-tab time-padding"' + ">" + -top[i].score + "</div>";
//        str += "<div class="+'"results-tab"'+">" + this.records[i][server.clickParameter] + "</div>";
				str += "</div>";
				recordTable.append(str);
			}
			return this.$emptyLeadersBlock.append(recordTable);
		};

		Statistics.prototype.setPlusOneClick = function () {
			this.currentClick += 1;
			return this.$currentClickText.text(this.currentClick);
		};

		Statistics.prototype.setPlusOneSecond = function () {
			statistics.currentTime += 1;
			return statistics.$currentTimeText.text(statistics.currentTime);
		};

		Statistics.prototype.showNameWindow = function () {
			return this.$playerNameBlock.removeClass("invisible");

		};

		Statistics.prototype.hideGameName = function () {
			return this.$gameNameBlock.addClass("invisible");
		};

		Statistics.prototype.showGameName = function () {
			return this.$gameNameBlock.removeClass("invisible");
		};


		Statistics.prototype.hideStats = function () {
			return this.$statsBlock.addClass("invisible");
		};

		Statistics.prototype.showStats = function () {
			return this.$statsBlock.removeClass("invisible");
		};

		Statistics.prototype.hideNameWindow = function () {
			return this.$playerNameBlock.addClass("invisible");
		};

		Statistics.prototype.showLeaderBoard = function () {
			return this.$leaderBoardBlock.removeClass("invisible");
		};

		Statistics.prototype.hideLeaderBoard = function () {
			return this.$leaderBoardBlock.addClass("invisible");
		};

		Statistics.prototype.resize = function () {
			// this.$inputNameBlock.css("margin-left", WINDOW_WIDTH / 2 - 300 / 2 + "px");
			// this.$inputNameBlock.css("margin-top", WINDOW_HEIGHT / 2 - 150 / 2 - 50 + "px");
			//this.$leaderTableBlock.css("margin-left", WINDOW_WIDTH / 2 - 400 / 2 + "px");
			//return this.$leaderTableBlock.css("margin-top", WINDOW_HEIGHT / 2 - 500 / 2 + "px");
		};

		return Statistics;

	})();

}).call(this);
